/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                 Java -- bohatstv knihoven                  //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2003                      // 
//                                                             //
/////////////////////////////////////////////////////////////////


import java.util.*;

class Osoba implements Comparable {
  int vyska;
  double vaha;
  String popis;

  Osoba(int vyska, double vaha, String popis) {
    this.vyska = vyska;
    this.vaha = vaha;
    this.popis = popis;
  }

  public int compareTo(Object os) {
    return this.vyska - ((Osoba) os).vyska;
  }

  public String toString() {
    return "vy = " + vyska + ", va = " + vaha + ", " + popis ;
  }
}

class KomparatorOsobyPodleVysky implements Comparator {
  public int compare(Object o1, Object o2) {
    int v1 = ((Osoba) o1).vyska;
    int v2 = ((Osoba) o2).vyska;
    return v1 - v2;
  }
}

class KomparatorOsobyPodleVahy implements Comparator {
  public int compare(Object o1, Object o2) {
    return (int) (((Osoba) o1).vaha - ((Osoba) o2).vaha);  
  }
}

class KomparatorOsobyPodlePopisu implements Comparator {
  public int compare(Object o1, Object o2) {
    String s1 = ((Osoba) o1).popis;
    String s2 = ((Osoba) o2).popis;
    return s1.compareTo(s2);
  }
}

public class ArraysVyhledavaniObecnychObjektu {
  static Osoba[] poleOsob;

  static void vypisOsoby() {
    for (int i = 0;  i < poleOsob.length;  i++)
      System.out.println("[" + i + "] " + poleOsob[i].toString());
  }

  static void najdi(double vaha) {
    Osoba os = new Osoba(0, vaha, "nedulezite");
    int k = Arrays.binarySearch(poleOsob, os,
                             new KomparatorOsobyPodleVahy());
    System.out.print("[" + k + "]=" + vaha);
    if (k < 0)
      System.out.println("\t[" + -(k + 1) + "]=" + vaha);
    else
      System.out.println();
  }

  public static void main(String[] args) {
    poleOsob = new Osoba[4];
    poleOsob[0] = new Osoba(186, 82.5, "muz");
    poleOsob[1] = new Osoba(172, 63.0, "zena");
    poleOsob[2] = new Osoba(105, 26.1, "dite");
    poleOsob[3] = new Osoba(116, 80.5, "obezni trpaslik");

    System.out.println("Absolutni razeni podle vahy");
    Arrays.sort(poleOsob, new KomparatorOsobyPodleVahy());
    vypisOsoby();

    najdi(60.0);
    najdi(63.0);
    najdi(20.0);
    najdi(99.0);
  }
}
