/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                 Java -- bohatstv knihoven                  //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2003                      // 
//                                                             //
/////////////////////////////////////////////////////////////////


import java.util.*;

class PorovnatelnaOsoba implements Comparable {
  int vyska;
  double vaha;
  String popis;

  PorovnatelnaOsoba(int vyska, double vaha, String popis) {
    this.vyska = vyska;
    this.vaha = vaha;
    this.popis = popis;
  }

  public int compareTo(Object os) {
    return this.vyska - ((PorovnatelnaOsoba) os).vyska;
  }

  public String toString() {
    return "vy = " + vyska + ", va = " + vaha + ", " + popis + "\n";
  }

  public static final Comparator PODLE_VYSKY = new Comparator() {
    public int compare(Object o1, Object o2) {
      return ((PorovnatelnaOsoba) o1).vyska - ((PorovnatelnaOsoba) o2).vyska;
    }
  };

  public static final Comparator PODLE_VAHY = new Comparator() {
    public int compare(Object o1, Object o2) {
      return (int) (((PorovnatelnaOsoba) o1).vaha - ((PorovnatelnaOsoba) o2).vaha);
    }
  };

  public static final Comparator PODLE_POPISU = new Comparator() {
    public int compare(Object o1, Object o2) {
      return ((PorovnatelnaOsoba) o1).popis.compareTo(((PorovnatelnaOsoba) o2).popis);
    }
  };
}


public class TestPorovnatelnaOsoba {
  static PorovnatelnaOsoba[] poleOsob;

  public static void main(String[] args) {
    poleOsob = new PorovnatelnaOsoba[4];
    poleOsob[0] = new PorovnatelnaOsoba(186, 82.5, "muz");
    poleOsob[1] = new PorovnatelnaOsoba(172, 63.0, "zena");
    poleOsob[2] = new PorovnatelnaOsoba(105, 26.1, "dite");
    poleOsob[3] = new PorovnatelnaOsoba(116, 80.5, "obezni trpaslik");

    Arrays.sort(poleOsob, PorovnatelnaOsoba.PODLE_VAHY);
    System.out.println("Absolutni razeni podle vahy:\n"
                        + Arrays.asList(poleOsob));

    Arrays.sort(poleOsob, PorovnatelnaOsoba.PODLE_POPISU);
    System.out.println("Absolutni razeni podle popisu:\n"
                        + Arrays.asList(poleOsob));

    Arrays.sort(poleOsob, PorovnatelnaOsoba.PODLE_VYSKY);
    System.out.println("Absolutni razeni podle vysky:\n"
                        + Arrays.asList(poleOsob));
  }
}
