/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                 Java -- bohatstv knihoven                  //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2003                      // 
//                                                             //
/////////////////////////////////////////////////////////////////


import java.util.*;

class Osoba implements Comparable {
  int vyska;
  double vaha;
  String popis;

  Osoba(int vyska, double vaha, String popis) {
    this.vyska = vyska;
    this.vaha = vaha;
    this.popis = popis;
  }

  public int compareTo(Object os) {
    return this.vyska - ((Osoba) os).vyska;
  }

  public String toString() {
    return "\r\nvy = " + vyska + ", va = " + vaha + ", " + popis;
  }
}

class KomparatorOsobyPodleVysky implements Comparator {
  public int compare(Object o1, Object o2) {
    int v1 = ((Osoba) o1).vyska;
    int v2 = ((Osoba) o2).vyska;
    return v1 - v2;
  }
}

class KomparatorOsobyPodleVahy implements Comparator {
  public int compare(Object o1, Object o2) {
    return (int) (((Osoba) o1).vaha - ((Osoba) o2).vaha);
  }
}

public class OsobaCollections {
  public static void main(String[] args) {
    List sez = new ArrayList();
    sez.add(new Osoba(186, 82.5, "muz"));
    sez.add(new Osoba(172, 63.0, "zena"));
    sez.add(new Osoba(105, 26.1, "dite"));
    sez.add(new Osoba(116, 80.5, "obezni trpaslik"));
    System.out.println("Nesetrideno: " + sez);

    Collections.sort(sez, new KomparatorOsobyPodleVahy());
    System.out.println("Absolutni razeni podle vahy: " + sez);

    Collections.reverse(sez);
    System.out.println("Podle vahy sestupne: " + sez);

    Collections.sort(sez);
    System.out.println("Prirozene razeni podle vysky: " + sez);

    Collections.shuffle(sez);
    System.out.println("Zamichano: " + sez);

    System.out.println("Nejvyssi:"
                        + Collections.max(sez));
    System.out.println("Nejlehci:"
                        + Collections.min(sez,
                        new KomparatorOsobyPodleVahy()));

    Collections.fill(sez, new Osoba(180, 75.0, "robot"));
    System.out.println("Vyplneno: " + sez);
  }
}
