/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//                 Java -- bohatstv knihoven                  //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2003                      // 
//                                                             //
/////////////////////////////////////////////////////////////////


import java.util.*;

class Ovoce {
  int cena;
  String typ;
  Ovoce(int cena) {
    this.cena = cena;
    byte[] b = new byte[5];
    for (int i = 0;  i < 5;  i++)
      b[i] = (byte) ((Math.random() * 26) + (byte) 'a');
    typ = new String(b);
  }

  public String toString() {
    return typ + ":" + cena + " Kc";
  }

  public int hashCode() {
    return typ.hashCode() * cena;
//    return cena;
  }

  public boolean equals(Object o) {
    if (o == this)
      return true;
    if (o instanceof Ovoce == false)
      return false;

    boolean stejnaCena = (cena == ((Ovoce) o).cena);
    boolean stejnyTyp = (typ == ((Ovoce) o).typ);
    return (stejnaCena && stejnyTyp);
  }
}

public class SlozitejsiHashCode {
  static final int POCET = 50000;

  public static void main(String[] args) {
    int n = 0;
    HashSet ovoceSet = new HashSet(POCET);
    for (int i = 0;  i < POCET;  i++) {
      int j = (int) (Math.random() * 20 + 10);
      ovoceSet.add(new Ovoce(j));
    }
    System.out.print("" + ovoceSet.size() + "=");

    Iterator it = ovoceSet.iterator();
    long zac = System.currentTimeMillis();
    while (it.hasNext()) {
      Ovoce o = (Ovoce) it.next();
      if (ovoceSet.contains(o) == true)
        n++;
    }
    long kon = System.currentTimeMillis();
    System.out.println("" + n + ": " + (kon - zac));
  }
}
